# Exercise 1a
n=10000
lambda=2
y=alg1a(lambda,n)
hist(y,20)

# Exercise 1b
n=10000
lambda=2
z=alg1b(lambda,n)
hist(y,20)

#Exercise 2 (Box-Muller: simulate X~N(0,1))
n=5000
X=alg2(n)
hist(X,20)

# Simulate Y~N(mu,sd^2) using the transformation Y=mu+sd*X
mu=3
sd=2
Y=mu+sd*X
hist(Y,20)

# Exercise 3 (Simulate W~Weibull(a,b)
n=10000
a=1
b=2
w=alg3(a,b,n)
hist(w,20)

# Exercise 4 (Simulate X~Cauchy)
a=0
b=1

n=100
xbar100=NULL
xvar100=NULL
for (i in 1:5) {
x=alg4(a,b,n)
xbar=mean(x)
xvar=var(x)
xbar100=c(xbar100,xbar)
xvar100=c(xvar100,xvar)
}
xbar100
xvar100


n=500
xbar500=NULL
xvar500=NULL
for (i in 1:5) {
x=alg4(a,b,n)
xbar=mean(x)
xvar=var(x)
xbar500=c(xbar500,xbar)
xvar500=c(xvar500,xvar)
}
xbar500
xvar500

n=1000
xbar1000=NULL
xvar1000=NULL
for (i in 1:5) {
x=alg4(a,b,n)
xbar=mean(x)
xvar=var(x)
xbar1000=c(xbar1000,xbar)
xvar1000=c(xvar1000,xvar)
}
xbar1000
xvar1000

n=10000
xbar10000=NULL
xvar10000=NULL
for (i in 1:5) {
x=alg4(a,b,n)
xbar=mean(x)
xvar=var(x)
xbar10000=c(xbar10000,xbar)
xvar10000=c(xvar10000,xvar)
}
xbar10000
xvar10000

# Exercise 5a (Simulate X~Bernoulli(p))
n=20
p=0.2
x1=alg5a(p,n)
x1

p=0.9
x2=alg5a(p,n)
x2

# Exercise 5b (Simulate from a discrete distribution)
n=10000
x=alg5b(n)
frequencies=rep(0,4)
for (i in 1:4) { 
freq=sum(x==i)/n 
frequencies[i]=freq
}
frequencies

n=10000
probs=c(0.3,0.2,0.2,0.3)
x=alg5c(probs,n)
frequencies1=rep(0,4)
for (i in 1:4) { 
freq=sum(x==i)/n 
frequencies1[i]=freq
}
frequencies1

n=10000
k=10
probs=(1/k)*rep(1,k)
x=alg5c(probs,n)
frequencies2=rep(0,k)
for (i in 1:k) { 
freq=sum(x==i)/n 
frequencies2[i]=freq
}
frequencies2

# Exercise 6 (Simulate from the logistic distribution using rejection sampling)
n=10000
x=alg6(n)
hist(x,20)

# Exercise 7 (Monte Carlo integration)
theta_hats1_100=rep(0,20)
theta_hats2_100=rep(0,20)
theta_hats1_500=rep(0,20)
theta_hats2_500=rep(0,20)
theta_hats1_1000=rep(0,20)
theta_hats2_1000=rep(0,20)
for (i in 1:20) {
theta_hats1_100[i]=alg7a(100)
theta_hats2_100[i]=alg7b(100)
theta_hats1_500[i]=alg7a(500)
theta_hats2_500[i]=alg7b(500)
theta_hats1_1000[i]=alg7a(1000)
theta_hats2_1000[i]=alg7b(1000)
}
mean(theta_hats1_100)
var(theta_hats1_100)
mean(theta_hats2_100)
var(theta_hats2_100)
mean(theta_hats1_500)
var(theta_hats1_500)
mean(theta_hats2_500)
var(theta_hats2_500)
mean(theta_hats1_1000)
var(theta_hats1_1000)
mean(theta_hats2_1000)
var(theta_hats2_1000)


